final int GAME_SPLASHSCREEN = 0;
final int GAME_LEVEL_SELECT = 1;
final int GAME_LEVEL_INFO = 2;
final int GAME_PLAYING = 3;
final int GAME_OVER = 4;

int gameState = GAME_SPLASHSCREEN;

PFont titleFont;
PFont headingFont;
PFont textFont;
PFont smallFont;

void setup() {
  size(640, 640);
  
  titleFont = createFont("data/kenney_fontpackage/Kenney Blocks.ttf", 64);
  headingFont = createFont("data/kenney_fontpackage/Kenney Blocks.ttf", 32);
  textFont = createFont("data/kenney_fontpackage/Kenney Mini Square.ttf", 16);
  smallFont = createFont("data/kenney_fontpackage/Kenney Mini Square.ttf", 8);
  
  setupImages();
}

void draw() {
  switch (gameState) {
    case GAME_SPLASHSCREEN:
      drawSplashScreen();
      break;
    case GAME_LEVEL_SELECT:
      drawLevelSelect();
      break;
    case GAME_LEVEL_INFO:
      drawLevelInfo();
      break;
    case GAME_PLAYING:
      drawPlaying();
      break;
    case GAME_OVER:
      drawGameOver();
      break;
  }
}

void keyPressed() {   
  switch (gameState) {
    case GAME_SPLASHSCREEN:
      keyPressedSplashScreen();
      break;
    case GAME_LEVEL_SELECT:
      keyPressedLevelSelect();
      break;
    case GAME_LEVEL_INFO:
      keyPressedLevelInfo();
      break;
    case GAME_OVER:
      keyPressedGameOver();
      break;
    case GAME_PLAYING:
      keyPressedPlaying();
      break;
  }
}
